import 'dart:convert';

import 'package:marianum_mobile/api/requestCache.dart';
import 'package:marianum_mobile/api/webuntis/queries/getRooms/getRoomsResponse.dart';

import 'getRooms.dart';

class GetRoomsCache extends RequestCache<GetRoomsResponse> {
  GetRoomsCache({onUpdate}) : super(60 * 60, onUpdate) {
    start("rooms", "data");
  }

  @override
  Future<GetRoomsResponse> onLoad() {
    return GetRooms().run();
  }

  @override
  GetRoomsResponse onLocalData(String json) {
    return GetRoomsResponse.fromJson(jsonDecode(json));
  }

}