import 'dart:convert';

import 'package:marianum_mobile/api/requestCache.dart';
import 'package:marianum_mobile/api/webuntis/queries/getSubjects/getSubjectsResponse.dart';

import 'getSubjects.dart';

class GetSubjectsCache extends RequestCache<GetSubjectsResponse> {
  GetSubjectsCache({onUpdate}) : super(60 * 60, onUpdate) {
    start("subjects", "data");
  }

  @override
  Future<GetSubjectsResponse> onLoad() {
    return GetSubjects().run();
  }

  @override
  onLocalData(String json) {
    return GetSubjectsResponse.fromJson(jsonDecode(json));
  }

}